/*This example draws voronoi diagram generated by a random set of points.*/

void setup() {
  size(800, 100, P3D); //size of your intended pattern
  noLoop(); // don't need to use the draw loop

  /*unique name for your file. if left unchanged,
   will simply save file with current milisecond*/
  String fileName= "voronoi"+millis()+".pdf";

  beginRaw(PDF, fileName); //enables you to save your design to a pdf


  setupVoronoi(); // create your voronoi generator

/*GRID*/
  int pointNum =10; //number of total points

  //generates a regular grid of pointNum x pointNum of points 
  for (int i=0;i<pointNum+1;i++) {
    for (int j=0;j<pointNum+1;j++) {

      float xCoord = width/pointNum*(i);
      float yCoord = height/pointNum*(j);
      voronoi.addPoint(new Vec2D(xCoord, yCoord));
    }
  }

/* SPIRAL */
  int centerLimit = 250; // variable to control the diameter of the spiral
  int theta = 0; //increases with every point in your spiral, producing the spiral effect.

  theta=0; //reset theta 
  for (int k=0;k<centerLimit;k++) {     
    theta +=1;

    //One spiral in center with large-ish shapes
    drawPoint(width/2, height/2, theta/4, theta/4);
  } 


  drawVoronoi(); //renders your voronoi
  endRaw(); //ends the recording
}

void drawPoint(float orgX, float orgY, float theta, float diameter) { //function that generates and adds circular points

  float xPos = sin(theta)*diameter+orgX;
  float yPos = cos(theta)*diameter+orgY;

  voronoi.addPoint(new Vec2D(xPos, yPos));
}




