/*This example illustrates a simple method to generate a set of deliberately placed
points to control the structure of a voronoi diagram. This particular example
combines spiral and circle structures to produce the overall design.*/


void setup() {
 size(500,500,P3D); //size of your intended pattern
 noLoop(); // don't need to use the draw loop
 
 /*unique name for your file. if left unchanged,
 will simply save file with current milisecond*/
 String fileName= "voronoi"+"Spiral_Final"+ millis() +".pdf";
  
  beginRaw(PDF, fileName); //enables you to save your design to a pdf
  
   
   setupVoronoi(); // create your voronoi generator
    
   // =========GENERATE SPIRALS=============== //
   
   
  int centerLimit = 250; // variable to control the diameter of the spiral
  int theta = 0; //increases with every point in your spiral, producing the spiral effect.

  theta=0; //reset theta 
  for(int k=0;k<centerLimit;k++){     
       theta +=1;
       
       //Large sprial in center
      drawPoint(width/2,height/2,theta/2,theta/2); 
       //Large spiral off to the left, three fourths down     
      drawPoint(width/8,3*height/4,theta/2,theta/2);


       //top right       
       drawPoint(width-width/8 ,height/4 ,theta/4,theta/4);       


       //3 clustered spirals in top left
       drawPoint(width/6,height/4,theta/4,theta/4);
       drawPoint(width/2,height/8,theta/4,theta/4);
       drawPoint(width/3,height/9,theta/3,theta/3);
       
       
       //Mirror image of the top 3 sprials in the left. Shown in bottom right
       drawPoint(5*width/6,3*height/4,theta/4,theta/4);
       drawPoint(width/2,7*height/8,theta/4,theta/4);
       drawPoint(2*width/3,8*height/9,theta/3,theta/3);

      } 
     
 
  
   drawVoronoi(); //renders your voronoi
   endRaw(); //ends the recording
 

}

void drawPoint(float orgX, float orgY, float theta, float diameter) { //function that generates and adds circular points
 
  float xPos = sin(theta)*diameter+orgX;
  float yPos = cos(theta)*diameter+orgY;
  
  voronoi.addPoint(new Vec2D(xPos, yPos));
}






